<template>
    <tr data-code-id={{code.id}}>
        <input type="hidden" name="id" class="form-control" :value="code.id">
        <th  scope="row">{{index + 1}}</th>
        <td v-if="editMode"><input v-model="code.number"></td>
        <td v-else>{{code.number}}</td>
        <td v-if="editMode"><input v-model="code.name"></td>
        <td v-else>{{code.name}}</td>
        <td v-if="editMode">
            <div class="form-check">
                <input class="form-check-input" type="checkbox" id="isActiveCheckbox"
                    v-model="code.isActive">
                <label class="form-check-label" for="isActiveCheckbox">
                    Активный
                </label>
            </div>
            <button type="button" class="btn btn-default" @click="saveCode">
                <svg width="1.4em" height="1.4em" viewBox="0 0 16 16" class="bi bi-check2 text-success" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" d="M13.854 3.646a.5.5 0 0 1 0 .708l-7 7a.5.5 0 0 1-.708 0l-3.5-3.5a.5.5 0 1 1 .708-.708L6.5 10.293l6.646-6.647a.5.5 0 0 1 .708 0z"/>
                </svg>
            </button>
            <button type="button" class="btn btn-default" @click="cancel">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-slash-circle text-danger" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" d="M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
                    <path fill-rule="evenodd" d="M11.354 4.646a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708l6-6a.5.5 0 0 1 .708 0z"/>
                </svg>
            </button>
        </td>
        <td v-else>
            <button type="button" class="btn btn-default" @click="startEditCode" :disabled="!isEditPossible">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-pencil-square" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                    <path d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456l-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                    <path fill-rule="evenodd" d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                </svg>
            </button>
            <button type="button" class="btn btn-default" @click="deleteCode" :disabled="!isEditPossible">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-trash" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                    <path d="M5.5 5.5A.5.5 0 0 1 6 6v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm2.5 0a.5.5 0 0 1 .5.5v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm3 .5a.5.5 0 0 0-1 0v6a.5.5 0 0 0 1 0V6z"/>
                    <path fill-rule="evenodd" d="M14.5 3a1 1 0 0 1-1 1H13v9a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V4h-.5a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1H6a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1h3.5a1 1 0 0 1 1 1v1zM4.118 4L4 4.059V13a1 1 0 0 0 1 1h6a1 1 0 0 0 1-1V4.059L11.882 4H4.118zM2.5 3V2h11v1h-11z"/>
                </svg>
            </button>
        </td>
    </tr>
</template>

<script>
    import { BudgetCodesService } from '../../services/budgetCodesService'
    import { defaultHandleErrorFunction } from '@/services/http-common'

    export default {
        name: 'BudgetCodeRow',
        props: {
            code: Object,
            index: Number,
            isEditPossible: Boolean
        },
        emits: ['update:isEditPossible', 'codeEdited'],
        data() {
            return {
                editMode: false
            }
        },
        methods: {
            startEditCode() {
                if (this.isEditPossible && !this.editMode) {
                    this.$emit('update:isEditPossible', false);
                    this.editMode = true;
                }
            },
            deleteCode() {
            },
            saveCode() {
                const budgetCodesService = new BudgetCodesService();
                budgetCodesService
                    .update({
                        Id: this.code.id,
                        MunicipalityId: this.code.municipalityId,
                        Number: this.code.number,
                        Name: this.code.name,
                        Type: this.code.type,
                        IsActive: this.code.isActive
                    })
                    .then(response => this.$emit('codeEdited'))
                    .catch(defaultHandleErrorFunction);
                this.$emit('update:isEditPossible', true);
                this.editMode = false;
            },
            cancel() {
                this.$emit('update:isEditPossible', true);
                this.editMode = false;
            }
        }
    };
</script>